#ifndef __FeaturePair_hpp__
#define __FeaturePair_hpp__

//#include "omscenedata.h"
#include "Feature.hpp"

class FeaturePair {

  const Feature * feature1_;    ///< The first feature's id.
  const Feature * feature2_;    ///< The second feature's id.

  IntegerRange imageRange_;     ///< The range of images that contain the pair.

public:

  FeaturePair( const Feature & feature1, const Feature & feature2 );

  const Feature & GetFirstFeature() const;
  const Feature & GetSecondFeature() const;

  const IntegerRange & GetImageRange() const;

};

#endif // __FeaturePair_hpp__
