#ifndef __ReconObject_hpp__
#define __ReconObject_hpp__

#include "vm3vector.h"

class ReconObject {

public:

  enum ReconFlag {
    RECON_NONE,
    RECON_ANCHOR,
    RECON_NONANCHOR
  };

private:

  int featureID_;
  ReconFlag reconFlag_;
  VM3Vector reconLocation_;

  union {
    float cosAngle_;
    float conditionNumber_;
  };
  float viewpointVariance_;
  float meanViewpointDistance_;

public:

  ReconObject();
  ReconObject( const ReconObject & reconObject );

  int GetFeatureID() const;
  void SetFeatureID( int featureID );

  ReconFlag GetReconFlag() const;
  const VM3Vector & GetReconLocation() const;
  float GetCosAngle() const;
  float GetConditionNumber() const;
  float GetViewpointVariance() const;
  float GetMeanViewpointDistance() const;

  void SetAnchorReconstruction( const VM3Vector & reconLocation, 
		  float cosAngle );
  void SetNonanchorReconstruction( const VM3Vector & reconLocation, 
		  float conditionNumber, float viewpointVariance, 
		  float meanViewpointDistance );

};

#include "ReconObject.ipp"

#endif // __ReconObject_hpp__
