#ifndef CVECTOR_ALREADY_INCLUDED
#define CVECTOR_ALREADY_INCLUDED

#include <common.h>

typedef float CVector[3];


/* Macros */
#define VecLength(vec)   		\
	(SQRT(SQR(vec[0]) + SQR(vec[1]) + SQR(vec[2])))

#define VecLengthSqr(vec)   		\
	(SQR(vec[0]) + SQR(vec[1]) + SQR(vec[2]))

#define VecNormalize(result)   		\
	if (1) {			\
   	float len = VecLength(result);	\
   	if (len != 0.0) {		\
         len = 1.0/len;			\
    	 result[0] *= len;		\
    	 result[1] *= len;		\
   	 result[2] *= len;		\
        } } else

#define VecScale(result, s, v)		\
	if (1) { 			\
   	result[0] = (s) * v[0];		\
   	result[1] = (s) * v[1];		\
   	result[2] = (s) * v[2];		\
	} else

#define VecNegate(result, v)		\
	if (1) {			\
   	result[0] = -v[0];		\
   	result[1] = -v[1];		\
   	result[2] = -v[2];		\
	} else

#define VecZero(v)			\
	if (1) {			\
   	v[0] = 0;			\
   	v[1] = 0;			\
   	v[2] = 0;			\
	} else

#define VecSubtract(result,a,b)		\
	if (1) {			\
   	result[0] = a[0] - b[0];	\
   	result[1] = a[1] - b[1];	\
   	result[2] = a[2] - b[2];	\
	} else

#define VecAdd(result,a,b)		\
	if (1) {			\
   	result[0] = a[0] + b[0];	\
   	result[1] = a[1] + b[1];	\
   	result[2] = a[2] + b[2];	\
	} else

#define VecSet(result,a,b,c)		\
	if (1) {			\
   	result[0] = a;			\
   	result[1] = b;			\
   	result[2] = c;			\
	} else

#define VecEqual(a, b)			\
	(FEQUAL((a)[0],(b)[0]) &&	\
	 FEQUAL((a)[1],(b)[1]) &&	\
	 FEQUAL((a)[2],(b)[2]))

#define VecCopy(dst,src)		\
	if (1) {			\
   	dst[0] = src[0];		\
   	dst[1] = src[1];		\
   	dst[2] = src[2];		\
	} else

#define VecSwap(a,b)			\
	if (1) {			\
	float _tmp;			\
	SWAP((a)[0],(b)[0],_tmp);	\
	SWAP((a)[1],(b)[1],_tmp);	\
	SWAP((a)[2],(b)[2],_tmp);	\
	} else

#define VecDotProduct(a,b)		\
	((a)[0]*(b)[0] + (a)[1]*(b)[1] + (a)[2]*(b)[2])

#define VecCrossProduct(result, a, b)		\
	if (1) {				\
   	CVector _tmp;				\
   	_tmp[0] = a[1] * b[2] - a[2] * b[1];	\
   	_tmp[1] = a[2] * b[0] - a[0] * b[2];	\
   	_tmp[2] = a[0] * b[1] - a[1] * b[0];	\
   	VecCopy(result, _tmp);			\
	} else

#define VecPrint(msg,v) 		\
	fprintf(stderr,"%s: (%1.8f, %1.8f, %1.8f)\n", msg, v[0], v[1], v[2]);


typedef float CVector2D[2];

/* Macros */
#define VecLength2D(v)   		\
	(SQRT(SQR(v[0]) + SQR(v[1])))

#define VecLengthSqr2D(v)   		\
	(SQR(v[0]) + SQR(v[1]))

#define VecNormalize2D(result) 		\
	if (1) {			\
   	float _len = VecLength2D(result);\
   	if (_len != 0.0) {		\
         _len = 1.0/_len;		\
    	 result[0] *= _len;		\
    	 result[1] *= _len;		\
        } } else

#define VecScale2D(result, s, v)	\
	if (1) { 			\
   	result[0] = s * v[0];		\
   	result[1] = s * v[1];		\
	} else

#define VecNegate2D(result, v)		\
	if (1) {			\
   	result[0] = -vec[0];		\
   	result[1] = -vec[1];		\
	} else

#define VecPerp2D(result, v)		\
	if (1) {			\
   	result[0] = -v[1];		\
   	result[1] =  v[0];		\
	} else

#define VecZero2D(v)			\
	if (1) {			\
   	v[0] = 0;			\
   	v[1] = 0;			\
	} else

#define VecSubtract2D(result,a,b)	\
	if (1) {			\
   	result[0] = a[0] - b[0];	\
   	result[1] = a[1] - b[1];	\
	} else

#define VecAdd2D(result,a,b)		\
	if (1) {			\
   	result[0] = a[0] + b[0];	\
   	result[1] = a[1] + b[1];	\
	} else

#define VecSet2D(result,a,b)		\
	if (1) {			\
   	result[0] = a;			\
   	result[1] = b;			\
	} else

#define VecEqual2D(a, b)			\
	(FEQUAL((a)[0],(b)[0]) &&	\
	 FEQUAL((a)[1],(b)[1]))

#define VecCopy2D(dst,src)		\
	if (1) {			\
   	dst[0] = src[0];		\
   	dst[1] = src[1];		\
	} else

#define VecDotProduct2D(a,b)		\
	((a)[0]*(b)[0] + (a)[1]*(b)[1])


#define VecPrint2D(msg,v) 		\
	fprintf(stderr,"%s: (%1.3f, %1.3f)\n", msg, v[0], v[1])







/* Prototypes -- too big for macros */
extern void VecPerp(CVector result, CVector v, int is_unit);


#endif
