#ifndef __AnchorReconstructor_hpp__
#define __AnchorReconstructor_hpp__

#include "SceneData.hpp"
#include "FeaturePair.hpp"

class SceneData;

class AnchorReconstructor {

  SceneData & sceneData_;
  float cosAngleThreshold_;

public:

  AnchorReconstructor( SceneData & sceneData, 
		  float cosAngleThreshold = 0.99875f );
  AnchorReconstructor( const AnchorReconstructor & anchorReconstructor );

  bool ReconstructAnchorPair( const FeaturePair & pair, int imageNumber ) const;

private:

  bool ChooseReconImages( const FeaturePair & pair, int imageIDs[], 
		  int imageNumber ) const;
  bool EstimateAnchorPair( const FeaturePair & pair, int imageIDs[], 
		  float p[], float cosAngle[2], int imageNumber ) const;

};

#endif // __AnchorReconstructor_hpp__
