#include "omscenedata.h"
#include <math.h>

#define PI 3.14159265358979323846
#define LENGTH_P 512
#define WIDTH_P 512
#define FOCUS 0.1
#define LENGTH_R 2*0.1*tan(PI/6)
#define WIDTH_R 2*0.1*tan(PI/6)

void estimate( OMSceneData & SmallBed, int Pid[][6], float p[], float angle[] )
{ VM3Vector Coord2[2][6],Coord3[2][6],Q[2],C[6];
  VM3Point CP;
  float k[2][2], CosAngle;
  int i,j,m,jj,mm;

  for ( i=0; i<2; i++ )
    angle[i]=1.0;
  
  for ( i=0; i<6; i++ )
  { CP=SmallBed.imageMatList[SmallBed.projList[Pid[0][i]].imageNum].cameraPosition();
    VM3Vector T(CP); 
    C[i]=T;
  }
  
  for ( i=0; i<2; i++ )
  { for ( j=0; j<6; j++ )
    { Coord2[i][j].set((SmallBed.projList[Pid[i][j]].coord.x()-LENGTH_P/2)/LENGTH_P*LENGTH_R,
                       (SmallBed.projList[Pid[i][j]].coord.y()-WIDTH_P/2)/WIDTH_P*WIDTH_R,
                       -FOCUS);
      Coord3[i][j]=SmallBed.imageMatList[SmallBed.projList[Pid[i][j]].imageNum].cameraDirection(Coord2[i][j]);
    }
  }
  
  for ( i=0; i<2; i++ )
  { for ( j=0; j<5; j++ )
    { for ( m=j+1; m<6; m++ )
      { CosAngle=Coord3[i][j].dot( Coord3[i][m] )/( Coord3[i][j].length()*Coord3[i][m].length() );
		if ( angle[i] > CosAngle )
        {  angle[i]=CosAngle;
           jj=j;
		   mm=m;
		}
	  }
	}
    if ( angle[i] > 0.99875 )
	  break;

    k[0][i]=(Coord3[i][jj].dot(C[mm]-C[jj])*Coord3[i][mm].dot(Coord3[i][mm])-
             Coord3[i][mm].dot(C[mm]-C[jj])*Coord3[i][jj].dot(Coord3[i][mm]))/
            (Coord3[i][jj].dot(Coord3[i][jj])*Coord3[i][mm].dot(Coord3[i][mm])-
             Coord3[i][jj].dot(Coord3[i][mm])*Coord3[i][jj].dot(Coord3[i][mm]));
    k[1][i]=(k[0][i]*Coord3[i][jj].dot(Coord3[i][jj])-Coord3[i][jj].dot(C[mm]-C[jj]))/Coord3[i][jj].dot(Coord3[i][mm]);
    Q[i]=C[jj]+k[0][i]*Coord3[i][jj];
  }

  if ( ( angle[0] > 0.99875 ) || ( angle[1] > 0.99875 ) )
    return;

  p[1]=Q[0].x();
  p[2]=Q[0].y();
  p[3]=Q[0].z();
  p[4]=Q[1].x();
  p[5]=Q[1].y();
  p[6]=Q[1].z();

  for ( i=0; i<6; i++)
  { p[7+2*i]=sqrt((Q[0]-C[i]).dot(Q[0]-C[i])/Coord2[0][i].dot(Coord2[0][i]));
    p[8+2*i]=sqrt((Q[1]-C[i]).dot(Q[1]-C[i])/Coord2[1][i].dot(Coord2[1][i]));
  }
}

  
