#include "FeaturePair.hpp"



/*****************************************************************************
*****************************************************************************/
FeaturePair::FeaturePair( const Feature & feature1, const Feature & feature2 ):
  feature1_( &feature1 ),
  feature2_( &feature2 ),
  imageRange_( Intersect( feature1.GetRange(), feature2.GetRange() ) )
{}


/*****************************************************************************
*****************************************************************************/
const Feature & FeaturePair::GetFirstFeature() const
{
  return *feature1_;
}


/*****************************************************************************
*****************************************************************************/
const Feature & FeaturePair::GetSecondFeature() const
{
  return *feature2_;
}


/*****************************************************************************
*****************************************************************************/
const IntegerRange & FeaturePair::GetImageRange() const
{
  return imageRange_;
}
