#include "SceneData.hpp"
#include "FeaturePair.hpp"
#include <math.h>


/*****************************************************************************

  Find the value of function at the point p[].

*****************************************************************************/
#if 1
float func( SceneData & sceneData, const FeaturePair & pair, int imageIDs[], 
		int imageNumber, float p[] )
{ 
  VM3Vector *C, *coord[2], Q[2];
  float *E[3], value=0;
  int i, j;

  for ( i=0; i<2; i++ )
    coord[i] = (VM3Vector *) malloc( imageNumber * sizeof( VM3Vector ) );

  for ( i=0; i<3; i++ )
    E[i] = (float *) malloc( imageNumber * sizeof( float ) );

  C = (VM3Vector *) malloc( imageNumber * sizeof( VM3Vector ) );
  
  for ( i=0; i<imageNumber; i++ )
    C[i] = sceneData.GetViewpointLocationList()[imageIDs[i]];
	//C[i].set( p[7+2*imageNumber+3*i], p[8+2*imageNumber+3*i], p[9+2*imageNumber+3*i] );  
  
  Q[0].set(p[1],p[2],p[3]);
  Q[1].set(p[4],p[5],p[6]);    
  
  for ( i=0; i<imageNumber; i++ )
  { coord[0][i].set( pair.GetFirstFeature().GetLocation(imageIDs[i]).x_ * 
		  		sceneData.GetCameraParameters().realLength, 
        pair.GetFirstFeature().GetLocation(imageIDs[i]).y_ * 
		  		sceneData.GetCameraParameters().realWidth,	
        -sceneData.GetCameraParameters().focus );
    coord[1][i].set( pair.GetSecondFeature().GetLocation(imageIDs[i]).x_ * 
			 	sceneData.GetCameraParameters().realLength,  
        pair.GetSecondFeature().GetLocation(imageIDs[i]).y_ * 
		  		sceneData.GetCameraParameters().realWidth,                  
        -sceneData.GetCameraParameters().focus );  
  }  
  
  for ( i=0; i<imageNumber; i++)
  { E[0][i]=
	  (Q[0]-C[i]).dot(Q[0]-C[i])-p[7+i*2]*p[7+i*2]*coord[0][i].dot(coord[0][i]);
    E[1][i]=
	  (Q[0]-C[i]).dot(Q[1]-C[i])-p[7+i*2]*p[8+i*2]*coord[0][i].dot(coord[1][i]);
    E[2][i]=
	  (Q[1]-C[i]).dot(Q[1]-C[i])-p[8+i*2]*p[8+i*2]*coord[1][i].dot(coord[1][i]);
  } 

  for ( i=0; i<3; i++) 
    for ( j=0; j<imageNumber; j++)
      value=value+E[i][j]*E[i][j];  

  for ( i=0; i<2; i++ )
    free( coord[i] );

  for ( i=0; i<3; i++ )
    free( E[i] );

  free( C );
  
  return value;
}


/*****************************************************************************

  Find the gradient of the function at the point p[].

*****************************************************************************/
void dfunc( SceneData & sceneData, const FeaturePair & pair, int imageIDs[], 
		int imageNumber, float p[], float xi[])
{ 
  VM3Vector *coord[2], Q[2], T[2], *C;
  float *E[3];
  int i, j;

  for ( i=0; i<2; i++ )
    coord[i] = (VM3Vector *) malloc( imageNumber * sizeof( VM3Vector ) );

  for ( i=0; i<3; i++ )
    E[i] = (float *) malloc( imageNumber * sizeof( float ) );

  C = (VM3Vector *) malloc( imageNumber * sizeof( VM3Vector ) );

  for ( i=0; i<imageNumber; i++ )
    C[i] = sceneData.GetViewpointLocationList()[imageIDs[i]];
	//C[i].set( p[7+2*imageNumber+3*i], p[8+2*imageNumber+3*i], p[9+2*imageNumber+3*i] );  

  Q[0].set(p[1],p[2],p[3]);
  Q[1].set(p[4],p[5],p[6]);

  for ( i=0; i<imageNumber; i++ )
  { coord[0][i].set( pair.GetFirstFeature().GetLocation(imageIDs[i]).x_ * 
		  		sceneData.GetCameraParameters().realLength,
       pair.GetFirstFeature().GetLocation(imageIDs[i]).y_ * 
		 		sceneData.GetCameraParameters().realWidth,
       -sceneData.GetCameraParameters().focus );
    coord[1][i].set( pair.GetSecondFeature().GetLocation(imageIDs[i]).x_ * 
			 	sceneData.GetCameraParameters().realLength,
       pair.GetSecondFeature().GetLocation(imageIDs[i]).y_ * 
		 		sceneData.GetCameraParameters().realWidth,                     
		 -sceneData.GetCameraParameters().focus );  
  }    
  
  for ( i=0; i<imageNumber; i++)
  { E[0][i]=
	  (Q[0]-C[i]).dot(Q[0]-C[i])-p[7+i*2]*p[7+i*2]*coord[0][i].dot(coord[0][i]);        
    E[1][i]=
	  (Q[0]-C[i]).dot(Q[1]-C[i])-p[7+i*2]*p[8+i*2]*coord[0][i].dot(coord[1][i]);	    
    E[2][i]=
	  (Q[1]-C[i]).dot(Q[1]-C[i])-p[8+i*2]*p[8+i*2]*coord[1][i].dot(coord[1][i]); 
  }

  for ( i=1; i<6+imageNumber*2+1; i++)
    xi[i]=0;

  for ( i=0; i<imageNumber; i++)
  { T[0]=4*(Q[0]-C[i])*E[0][i]+2*(Q[1]-C[i])*E[1][i];
    T[1]=4*(Q[1]-C[i])*E[2][i]+2*(Q[0]-C[i])*E[1][i];
    xi[1]=xi[1]+T[0].x();
    xi[2]=xi[2]+T[0].y();
    xi[3]=xi[3]+T[0].z();
    xi[4]=xi[4]+T[1].x();
    xi[5]=xi[5]+T[1].y();
    xi[6]=xi[6]+T[1].z();  
  }  

  for ( i=0; i<imageNumber; i++)
  { xi[7+i*2]=2*E[0][i]*(-2*p[7+i*2]*coord[0][i].dot(coord[0][i]))+
	   2*E[1][i]*(-p[8+i*2]*coord[0][i].dot(coord[1][i]));
    xi[8+i*2]=2*E[2][i]*(-2*p[8+i*2]*coord[1][i].dot(coord[1][i]))+
	   2*E[1][i]*(-p[7+i*2]*coord[0][i].dot(coord[1][i]));
  }

  for ( i=0; i<2; i++ )
    free( coord[i] );

  for ( i=0; i<3; i++ )
    free( E[i] );

  free( C );
  
}
#endif

#if 0
float func( SceneData & sceneData, VM2Point **imageLocation, float p[] )
{ 
	VM3Vector C[3], coord[6][3], Q[6];
	float E[15][3], value=0;
	int i, j;
	
	for ( i=0; i<6; i++ )
		Q[i].set( p[1+3*i], p[2+3*i], p[3+3*i] );
	
	for ( i=0; i<3; i++ )
		C[i].set( p[1+3*6+3*i], p[2+3*6+3*i], p[3+3*6+3*i] );  
  
	for ( i=0; i<6; i++ )
		for ( j=0; j<3; j++ )
			coord[i][j].set( imageLocation[i][j].x() * sceneData.GetCameraParameters().realLength,
			                 imageLocation[i][j].y() * sceneData.GetCameraParameters().realWidth, 
							 -sceneData.GetCameraParameters().focus );
	
	for ( i=0; i<3; i++)
	{
		E[0][i] = (Q[0]-C[i]).dot(Q[0]-C[i])-p[28+i]*p[28+i]*coord[0][i].dot(coord[0][i]);
		E[1][i] = (Q[0]-C[i]).dot(Q[1]-C[i])-p[28+i]*p[31+i]*coord[0][i].dot(coord[1][i]);
		E[2][i] = (Q[1]-C[i]).dot(Q[1]-C[i])-p[31+i]*p[31+i]*coord[1][i].dot(coord[1][i]);

		for ( j=2; j<6; j++ )
		{
			E[3*(j-1)][i] = (Q[j]-C[i]).dot(Q[j]-C[i])-p[28+3*j+i]*p[28+3*j+i]*coord[j][i].dot(coord[j][i]);
			E[3*(j-1)+1][i] = (Q[j]-C[i]).dot(Q[0]-C[i])-p[28+3*j+i]*p[28+i]*coord[j][i].dot(coord[0][i]);
			E[3*(j-1)+2][i] = (Q[j]-C[i]).dot(Q[1]-C[i])-p[28+3*j+i]*p[31+i]*coord[j][i].dot(coord[1][i]);
		}
	}
	
	for ( i=0; i<15; i++) 
		for ( j=0; j<3; j++)
			value=value+E[i][j]*E[i][j];  
	
	return value;
}

void dfunc( SceneData & sceneData, VM2Point **imageLocation, float p[], float xi[])
{ 
	VM3Vector C[3], coord[6][3], Q[6], T[2];
	float E[15][3];
	int i, j;
	
	for ( i=0; i<6; i++ )
		Q[i].set( p[1+3*i], p[2+3*i], p[3+3*i] );
	
	for ( i=0; i<3; i++ )
		C[i].set( p[1+3*6+3*i], p[2+3*6+3*i], p[3+3*6+3*i] );  
  
	for ( i=0; i<6; i++ )
		for ( j=0; j<3; j++ )
			coord[i][j].set( imageLocation[i][j].x() * sceneData.GetCameraParameters().realLength,
			                 imageLocation[i][j].y() * sceneData.GetCameraParameters().realWidth, 
							 -sceneData.GetCameraParameters().focus );
	
	for ( i=0; i<3; i++)
	{
		E[0][i] = (Q[0]-C[i]).dot(Q[0]-C[i])-p[28+i]*p[28+i]*coord[0][i].dot(coord[0][i]);
		E[1][i] = (Q[0]-C[i]).dot(Q[1]-C[i])-p[28+i]*p[31+i]*coord[0][i].dot(coord[1][i]);
		E[2][i] = (Q[1]-C[i]).dot(Q[1]-C[i])-p[31+i]*p[31+i]*coord[1][i].dot(coord[1][i]);

		for ( j=2; j<6; j++ )
		{
			E[3*(j-1)][i] = (Q[j]-C[i]).dot(Q[j]-C[i])-p[28+3*j+i]*p[28+3*j+i]*coord[j][i].dot(coord[j][i]);
			E[3*(j-1)+1][i] = (Q[j]-C[i]).dot(Q[0]-C[i])-p[28+3*j+i]*p[28+i]*coord[j][i].dot(coord[0][i]);
			E[3*(j-1)+2][i] = (Q[j]-C[i]).dot(Q[1]-C[i])-p[28+3*j+i]*p[31+i]*coord[j][i].dot(coord[1][i]);
		}
	}
	
	for ( i=1; i<46; i++)
		xi[i]=0;

	for ( i=0; i<3; i++ )
	{
		T[0] = 4*(Q[0]-C[i])*E[0][i]+2*(Q[1]-C[i])*E[1][i];
		T[1] = 4*(Q[1]-C[i])*E[2][i]+2*(Q[0]-C[i])*E[1][i];
		xi[1]=xi[1]+T[0].x();
		xi[2]=xi[2]+T[0].y();
		xi[3]=xi[3]+T[0].z();
		xi[4]=xi[4]+T[1].x();
		xi[5]=xi[5]+T[1].y();
		xi[6]=xi[6]+T[1].z();

		for ( j=2; j<6; j++ )
		{
			T[0] = 2*(Q[j]-C[i])*E[3*(j-1)+1][i];
			T[1] = 2*(Q[j]-C[i])*E[3*(j-1)+2][i];
			xi[1]=xi[1]+T[0].x();
			xi[2]=xi[2]+T[0].y();
			xi[3]=xi[3]+T[0].z();
			xi[4]=xi[4]+T[1].x();
			xi[5]=xi[5]+T[1].y();
			xi[6]=xi[6]+T[1].z();
		}
	}

	for ( i=0; i<3; i++ )
	{
		for ( j=2; j<6; j++ )
		{
			T[0] = 4*(Q[j]-C[i])*E[3*(j-1)][i]+2*(Q[0]-C[i])*E[3*(j-1)+1][i]+2*(Q[1]-C[i])*E[3*(j-1)+2][i];
			xi[3*j+1]=xi[3*j+1]+T[0].x();
			xi[3*j+2]=xi[3*j+2]+T[0].y();
			xi[3*j+3]=xi[3*j+3]+T[0].z();
		}
	}

	for ( i=0; i<3; i++ )
	{
		T[0] = 4*(C[i]-Q[0])*E[0][i]+2*(C[i]-Q[0])*E[1][i]+2*(C[i]-Q[1])*E[1][i]+4*(C[i]-Q[1])*E[2][i];
		xi[19+3*i]=xi[19+3*i]+T[0].x();
		xi[20+3*i]=xi[20+3*i]+T[0].y();
		xi[21+3*i]=xi[21+3*i]+T[0].z();

		for ( j=2; j<6; j++ )
		{
			T[0] = 4*(C[i]-Q[j])*E[3*(j-1)][i]+
				   2*(C[i]-Q[0])*E[3*(j-1)+1][i]+
				   2*(C[i]-Q[j])*E[3*(j-1)+1][i]+
				   2*(C[i]-Q[1])*E[3*(j-1)+2][i]+
				   2*(C[i]-Q[j])*E[3*(j-1)+2][i];
			xi[19+3*i]=xi[19+3*i]+T[0].x();
			xi[20+3*i]=xi[20+3*i]+T[0].y();
			xi[21+3*i]=xi[21+3*i]+T[0].z();
		}
	}

	for ( i=0; i<3; i++)
	{
		xi[28+i] = xi[28+i]+2*E[0][i]*(-2*p[28+i]*coord[0][i].dot(coord[0][i]))
			               +2*E[1][i]*(-p[31+i]*coord[0][i].dot(coord[1][i]));
		xi[31+i] = xi[31+i]+2*E[2][i]*(-2*p[31+i]*coord[1][i].dot(coord[1][i]))
			               +2*E[1][i]*(-p[28+i]*coord[0][i].dot(coord[1][i]));

		for ( j=2; j<6; j++ )
		{
			xi[28+i] = xi[28+i]+2*E[3*(j-1)+1][i]*(-p[28+3*j+i]*coord[j][i].dot(coord[0][i]));
			xi[31+i] = xi[31+i]+2*E[3*(j-1)+2][i]*(-p[28+3*j+i]*coord[j][i].dot(coord[1][i]));
			xi[28+3*j+i] = xi[28+3*j+i]+2*E[3*(j-1)][i]*(-2*p[28+3*j+i]*coord[j][i].dot(coord[j][i]))
				                       +2*E[3*(j-1)+1][i]*(-p[28+i]*coord[j][i].dot(coord[0][i]))
									   +2*E[3*(j-1)+2][i]*(-p[31+i]*coord[j][i].dot(coord[1][i]));
		}
	}
} 
#endif

#if 1

struct ImageProjection
{
	VM3Vector *projection;
	VM3Vector *object;
	float *gamma;
	int *featureID;
	int size;
};

float funcAll( SceneData & sceneData, float p[] )
{ 
  VM3Vector *cameraCenter;
  ImageProjection *imageProjection;
  float **E, value=0;
  int i, j, k, gammaID=0;

  const std::vector<Feature> & featureList = sceneData.GetFeatureList();
  const std::vector<VM3Vector> & viewpointLocationList = sceneData.GetViewpointLocationList();

  cameraCenter = ( VM3Vector * ) malloc( viewpointLocationList.size() * sizeof( VM3Vector ) );
  imageProjection = ( ImageProjection * ) malloc( viewpointLocationList.size() * sizeof( ImageProjection ) );
  E = ( float ** ) malloc( viewpointLocationList.size() * sizeof( float * ) );

  for ( i=0; i<viewpointLocationList.size(); i++ )
	  cameraCenter[i].set( p[1+3*featureList.size()+3*i], p[2+3*featureList.size()+3*i], p[3+3*featureList.size()+3*i] );
  
  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  imageProjection[i].projection = ( VM3Vector * ) malloc( featureList.size() * sizeof( VM3Vector ) );
	  imageProjection[i].object = ( VM3Vector * ) malloc( featureList.size() * sizeof( VM3Vector ) );
	  imageProjection[i].gamma = ( float * ) malloc( featureList.size() * sizeof( float ) );
	  imageProjection[i].featureID = ( int * ) malloc( featureList.size() * sizeof( int ) );
	  imageProjection[i].size = 0;
	  
	  for ( j=0; j<featureList.size(); j++ )
	  {
		  if ( featureList[j].GetRange().GetLowerBound() <= i && featureList[j].GetRange().GetUpperBound() > i )
		  {
			  imageProjection[i].projection[imageProjection[i].size].set( featureList[j].GetLocation(i).x_ * sceneData.GetCameraParameters().realLength,
				                                                          featureList[j].GetLocation(i).y_ * sceneData.GetCameraParameters().realWidth,
													                      -sceneData.GetCameraParameters().focus );
			  imageProjection[i].object[imageProjection[i].size].set( p[1+3*j], p[2+3*j], p[3+3*j] );
			  imageProjection[i].gamma[imageProjection[i].size] = p[1+3*featureList.size()+3*viewpointLocationList.size()+gammaID];
			  imageProjection[i].featureID[imageProjection[i].size] = j;
			  imageProjection[i].size++;
			  gammaID++;
		  }
	  }
  }

  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  E[i] = ( float * ) malloc( imageProjection[i].size * imageProjection[i].size * sizeof( float ) );

	  for ( j=0; j<imageProjection[i].size; j++ )
	  {
		  for ( k=0; k<imageProjection[i].size; k++ )
		  {
			  if ( k<j )
				  E[i][j*imageProjection[i].size+k] = 0;
			  else
				  E[i][j*imageProjection[i].size+k] = (imageProjection[i].object[j]-cameraCenter[i]).dot(imageProjection[i].object[k]-cameraCenter[i])-
			                            			   imageProjection[i].gamma[j]*imageProjection[i].gamma[k]*
													   imageProjection[i].projection[j].dot(imageProjection[i].projection[k]);

			  /*printf("%d %d %d %f\n", i, imageProjection[i].featureID[j], imageProjection[i].featureID[k], E[i][j*imageProjection[i].size+k]);
			  imageProjection[i].object[j].print(stdout);
			  imageProjection[i].object[k].print(stdout);
			  cameraCenter[i].print(stdout);
			  printf("%f %f\n", imageProjection[i].gamma[j], imageProjection[i].gamma[k] );
			  imageProjection[i].projection[j].print(stdout);
			  imageProjection[i].projection[k].print(stdout);
			  printf("\n");*/
		  }
	  }
  }

  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  for ( j=0; j<imageProjection[i].size * imageProjection[i].size; j++ )
	  {
		  value=value+E[i][j]*E[i][j];
	  }
  }

  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  free( E[i] );
	  free( imageProjection[i].projection );
	  free( imageProjection[i].object );
	  free( imageProjection[i].gamma );
	  free( imageProjection[i].featureID );
  }

  free( E );
  free( imageProjection );
  free( cameraCenter );

  //printf("%f\n", value);
  
  return value;
}


/*****************************************************************************

  Find the gradient of the function at the point p[].

*****************************************************************************/
void dfuncAll( SceneData & sceneData, float p[], float xi[])
{ 
  VM3Vector *cameraCenter;
  ImageProjection *imageProjection;
  float **E, value=0;
  int i, j, k, l, gammaID=0;

  const std::vector<Feature> & featureList = sceneData.GetFeatureList();
  const std::vector<VM3Vector> & viewpointLocationList = sceneData.GetViewpointLocationList();

  cameraCenter = ( VM3Vector * ) malloc( viewpointLocationList.size() * sizeof( VM3Vector ) );
  imageProjection = ( ImageProjection * ) malloc( viewpointLocationList.size() * sizeof( ImageProjection ) );
  E = ( float ** ) malloc( viewpointLocationList.size() * sizeof( float * ) );

  for ( i=0; i<viewpointLocationList.size(); i++ )
	  cameraCenter[i].set( p[1+3*featureList.size()+3*i], p[2+3*featureList.size()+3*i], p[3+3*featureList.size()+3*i] );
  
  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  imageProjection[i].projection = ( VM3Vector * ) malloc( featureList.size() * sizeof( VM3Vector ) );
	  imageProjection[i].object = ( VM3Vector * ) malloc( featureList.size() * sizeof( VM3Vector ) );
	  imageProjection[i].gamma = ( float * ) malloc( featureList.size() * sizeof( float ) );
	  imageProjection[i].featureID = ( int * ) malloc( featureList.size() * sizeof( int ) );
	  imageProjection[i].size = 0;
	  
	  for ( j=0; j<featureList.size(); j++ )
	  {
		  if ( featureList[j].GetRange().GetLowerBound() <= i && featureList[j].GetRange().GetUpperBound() > i )
		  {
			  imageProjection[i].projection[imageProjection[i].size].set( featureList[j].GetLocation(i).x_ * sceneData.GetCameraParameters().realLength,
				                                                          featureList[j].GetLocation(i).y_ * sceneData.GetCameraParameters().realWidth,
													                      -sceneData.GetCameraParameters().focus );
			  imageProjection[i].object[imageProjection[i].size].set( p[1+3*j], p[2+3*j], p[3+3*j] );
			  imageProjection[i].gamma[imageProjection[i].size] = p[1+3*featureList.size()+3*viewpointLocationList.size()+gammaID];
			  imageProjection[i].featureID[imageProjection[i].size] = j;
			  imageProjection[i].size++;
			  gammaID++;
		  }
	  }
  }

  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  E[i] = ( float * ) malloc( imageProjection[i].size * imageProjection[i].size * sizeof( float ) );
	  
	  for ( j=0; j<imageProjection[i].size; j++ )
	  {
		  for ( k=0; k<imageProjection[i].size; k++ )
		  {
			  if ( k<j )
				  E[i][j*imageProjection[i].size+k] = 0;
			  else
				  E[i][j*imageProjection[i].size+k] = (imageProjection[i].object[j]-cameraCenter[i]).dot(imageProjection[i].object[k]-cameraCenter[i])-
			                                           imageProjection[i].gamma[j]*imageProjection[i].gamma[k]*
													   imageProjection[i].projection[j].dot(imageProjection[i].projection[k]);
		  }
	  }
  }

  for ( i=1; i<1+3*featureList.size()+3*viewpointLocationList.size()+gammaID; i++)
	  xi[i]=0;  

  for ( i=0; i<featureList.size(); i++)
  {
	  int lowerBound = featureList[i].GetRange().GetLowerBound();
	  int upperBound = featureList[i].GetRange().GetUpperBound();
	  VM3Vector T( 0.0, 0.0, 0.0 );

	  for ( j=lowerBound; j<upperBound; j++ )
	  {
		  for ( k=0; k<imageProjection[j].size; k++ )
			  if ( i == imageProjection[j].featureID[k] )
				  break;
		  for ( l=0; l<k; l++ )
			  T = T + 2*E[j][l*imageProjection[j].size+k] * ( imageProjection[j].object[l]-cameraCenter[j] );
		  for ( l=k+1; l<imageProjection[j].size; l++ )
			  T = T + 2*E[j][k*imageProjection[j].size+l] * ( imageProjection[j].object[l]-cameraCenter[j] );
		  T = T + 2*E[j][k*imageProjection[j].size+k] * 2 * ( imageProjection[j].object[k]-cameraCenter[j] );
	  }

	  xi[1+3*i] = T.x();
	  xi[2+3*i] = T.y();
	  xi[3+3*i] = T.z();  
  }

  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  VM3Vector T( 0.0, 0.0, 0.0 );;
	  
	  for ( j=0; j<imageProjection[i].size; j++ )
		  for ( k=j; k<imageProjection[i].size; k++ )
			  T = T + 2*E[i][j*imageProjection[i].size+k] * ( 2*cameraCenter[i]-imageProjection[i].object[j]-imageProjection[i].object[k] );

	  xi[1+3*featureList.size()+3*i] = T.x();
	  xi[2+3*featureList.size()+3*i] = T.y();
	  xi[3+3*featureList.size()+3*i] = T.z();
  }

  int currentGammaID = 0;
  
  /*for ( i=0; i<gammaID; i++, currentGammaID++ )
  {
	  if ( currentGammaID>=imageProjection[currentImageID].size )
	  {
		  currentGammaID = 0;
		  currentImageID++;
	  }

	  for ( j=0; j<currentGammaID; j++ )
		  xi[1+3*featureList.size()+3*viewpointLocationList.size()+i] += -2*E[currentImageID][j*imageProjection[currentImageID].size+currentGammaID]*
		                         imageProjection[currentImageID].gamma[j]*
		                         imageProjection[currentImageID].projection[j].dot(imageProjection[currentImageID].projection[currentGammaID]);

	  for ( j=currentGammaID+1; j<imageProjection[currentImageID].size; j++ )
		  xi[1+3*featureList.size()+3*viewpointLocationList.size()+i] += -2*E[currentImageID][currentGammaID*imageProjection[currentImageID].size+j]*
		                         imageProjection[currentImageID].gamma[j]*
		                         imageProjection[currentImageID].projection[j].dot(imageProjection[currentImageID].projection[currentGammaID]);

	  xi[1+3*featureList.size()+3*viewpointLocationList.size()+i] += -2*E[currentImageID][currentGammaID*imageProjection[currentImageID].size+currentGammaID]*
		                         2*imageProjection[currentImageID].gamma[currentGammaID]*
		                         imageProjection[currentImageID].projection[currentGammaID].dot(imageProjection[currentImageID].projection[currentGammaID]);
  }*/

  for ( i=0; i < viewpointLocationList.size(); i++ )
  {
	  for ( j=0; j < imageProjection[i].size; j++ )
	  {
		  for ( k=0; k<j; k++ )
			  xi[1+3*featureList.size()+3*viewpointLocationList.size()+currentGammaID] += 
			                     -2*E[i][k*imageProjection[i].size+j]*
		                         imageProjection[i].gamma[k]*
		                         imageProjection[i].projection[k].dot(imageProjection[i].projection[j]);

		  for ( k=j+1; k<imageProjection[i].size; k++ )
			  xi[1+3*featureList.size()+3*viewpointLocationList.size()+currentGammaID] += 
			                     -2*E[i][j*imageProjection[i].size+k]*
		                         imageProjection[i].gamma[k]*
		                         imageProjection[i].projection[j].dot(imageProjection[i].projection[k]);

		  xi[1+3*featureList.size()+3*viewpointLocationList.size()+currentGammaID] += 
			                     -2*E[i][j*imageProjection[i].size+j]*
		                         2*imageProjection[i].gamma[j]*
		                         imageProjection[i].projection[j].dot(imageProjection[i].projection[j]);
		  currentGammaID++;
	  }
  }

  
  for ( i=0; i<viewpointLocationList.size(); i++ )
  {
	  free( E[i] );
	  free( imageProjection[i].projection );
	  free( imageProjection[i].object );
	  free( imageProjection[i].gamma );
	  free( imageProjection[i].featureID );
  }

  free( E );
  free( imageProjection );
  free( cameraCenter );
}
#endif

