#include "omscenedata.h"

#define FTOL 1.0e-20

float func( OMSceneData & SmallBed, int Pid[][6], float p[] );
void dfunc( OMSceneData & SmallBed, int Pid[][6], float p[], float xi[]);
void frprmn( OMSceneData & SmallBed, int Pid[][6], float p[], int n, float ftol, int *iter, float *fret, 
     float (*func)( OMSceneData &, int [][6], float []), void (*dfunc)( OMSceneData &, int [][6], float [], float []));
void estimate( OMSceneData & SmallBed, int Pid[][6], float p[], float angle[] );

void GetAnchorPoints( OMSceneData & SmallBed, int Pid[][6], float O[][3], float angle[] )
{ int i,j;
  int iter;
  float fret;
  float p[19];

  estimate( SmallBed, Pid, p, angle );

  if ( ( angle[0] > 0.99875 ) || ( angle[1] > 0.99875 ) ) {
    printf( "Skipping nonlinear reconstruction.\n" );
    return;
  }

  frprmn( SmallBed, Pid, p, 18, FTOL, &iter, &fret, func, dfunc );

  for ( i=0; i<2; i++ )
    for ( j=0; j<3; j++ )
      O[i][j]=p[i*3+j+1];
}
