inline ReconObject::ReconObject():
  featureID_( -1 ),
  reconFlag_( RECON_NONE ),
  conditionNumber_( 0 ),
  viewpointVariance_( 0 ),
  meanViewpointDistance_( 0 )
{}

inline ReconObject::ReconObject( const ReconObject & reconObject ):
  featureID_( reconObject.featureID_ ),
  reconFlag_( reconObject.reconFlag_ ),
  reconLocation_( reconObject.reconLocation_ ),
  conditionNumber_( reconObject.conditionNumber_ ),
  viewpointVariance_( reconObject.viewpointVariance_ ),
  meanViewpointDistance_( reconObject.meanViewpointDistance_ )
{}

inline int ReconObject::GetFeatureID() const
{
  return featureID_;
}

inline void ReconObject::SetFeatureID( int featureID )
{
  featureID_ = featureID;
}

inline ReconObject::ReconFlag ReconObject::GetReconFlag() const
{
  return reconFlag_;
}

inline const VM3Vector & ReconObject::GetReconLocation() const
{
  return reconLocation_;
}

inline float ReconObject::GetCosAngle() const
{
  return cosAngle_;
}

inline float ReconObject::GetConditionNumber() const
{
  return conditionNumber_;
}

inline float ReconObject::GetViewpointVariance() const
{
  return viewpointVariance_;
}

inline float ReconObject::GetMeanViewpointDistance() const
{
  return meanViewpointDistance_;
}

inline void ReconObject::SetAnchorReconstruction( const VM3Vector & reconLocation, float cosAngle )
{
  reconFlag_ = RECON_ANCHOR;
  reconLocation_ = reconLocation;
  cosAngle_ = cosAngle;
}

inline void ReconObject::SetNonanchorReconstruction( const VM3Vector & reconLocation, float conditionNumber,
    float viewpointVariance, float meanViewpointDistance )
{
  reconFlag_ = RECON_NONANCHOR;
  reconLocation_ = reconLocation;
  conditionNumber_ = conditionNumber;
  viewpointVariance_ = viewpointVariance;
  meanViewpointDistance_ = meanViewpointDistance;
}
