#include "Validator.hpp"
#include <iostream>
#include <map>
#include <vector>

using namespace std;

bool Validate( const vector<Feature> & features, const vector<Feature> & anchors, int anchorsPerCamera )
{
  typedef vector<Feature>::const_iterator Iter;

  //
  // Initialize a the camera anchor counts.
  //
  map<int, vector<int> > cameraAnchors;
  //Iter feature = features.begin(), lastFeature = features.end();
  //for( ; feature != lastFeature; ++feature ) {
    //int lowerBound = feature->GetRange().GetLowerBound();
    //int upperBound = feature->GetRange().GetUpperBound();
    //for( int i=lowerBound; i<upperBound; ++i )
      //cameraAnchors[i] = 0;
  //}

  //
  // Count the camera's anchors.
  //
  Iter anchor = anchors.begin(), lastAnchor = anchors.end();
  for( ; anchor != lastAnchor; ++anchor ) {
    int lowerBound = anchor->GetRange().GetLowerBound();
    int upperBound = anchor->GetRange().GetUpperBound();
    for( int i=lowerBound; i<upperBound; ++i )
      cameraAnchors[i].push_back( anchor->GetObjectID() );
  }

  //
  // Verify that each camera has the required number of anchors.
  //
  map<int, vector<int> >::const_iterator camera = cameraAnchors.begin(), lastCamera = cameraAnchors.end();
  for( ; camera != lastCamera; ++camera )
    if( camera->second.size() < anchorsPerCamera )
      return false;

  //
  // Print out the anchor point id's for each image.
  //
  camera = cameraAnchors.begin(), lastCamera = cameraAnchors.end();
  for( ; camera != lastCamera; ++camera ) {
	  cout << camera->first << " ";
	  for( size_t i=0; i<camera->second.size() && i<2; ++i )
		  cout << camera->second[i] << " ";
	  cout << endl;
  }

  return true;
}
