#ifndef SOLVE_ALREADY_INCLUDED
#define SOLVE_ALREADY_INCLUDED

#include <vmarray.h>
#include <vm3point.h>
#include "omscenedata.h"
#include "AnchorId.h"
#include "Feature.hpp"
#include "FeaturePair.hpp"
#include <map>
#include <vector>
#include <deque>

#define MAX_TNUM 50    // max number of cameras
#define MAX_ONUM 50   // max number of objects

typedef float TwoFloats[2+1];

extern void solveForObjectPoints(
   VM3Point  O[MAX_ONUM+1],
   VM3Point  C[MAX_TNUM+1],
   VM3Vector N[MAX_TNUM+1],
   VM3Point  Oapprox[MAX_ONUM+1],
   float     pict[MAX_TNUM+1][2+1][MAX_ONUM+1],
   int tnum, int onum, int t0, int n0);

void SolveForAllObjectPoints( VMArray<VM4Matrix> & imageMatList, VMArray<OMSceneProjEntry> & projList, 
		const std::vector<Feature> & features, std::deque<FeaturePair*> & anchormap, 
		VMArray<VM3Point> & reconObjectList, VMArray<int> & reconObjectFlag, VMArray<float> & Angle, VMArray<float> & Std_C, VMArray<float> & reconObjectDistance );

#endif
