#include "vm2matrix.h"



/*****************************************************************************

  Rotate the matrix by 'radians'.

*****************************************************************************/
void 
VM2Matrix::rotate(float radians)
{
   float sinTheta = SIN(radians);
   float cosTheta = COS(radians);
   VM2Matrix m;

   m.mat[0][0] = cosTheta;
   m.mat[1][1] = cosTheta;
   m.mat[0][1] = -sinTheta;
   m.mat[1][0] = sinTheta;

   (*this) = (*this) * m;
}


/*****************************************************************************
*****************************************************************************/
int
VM2Matrix::invert()
{
   float a    = mat[0][0];
   float b    = mat[0][1];
   float c    = mat[1][0];
   float d    = mat[1][1];
   float invD = 1.0 / determinant();

   mat[0][0] = invD *  d; mat[0][1] = invD * -b;
   mat[1][0] = invD * -c; mat[1][1] = invD *  a;

   return (TRUE);
}
