#include "vm2point.h"
#include <vm2vector.h>
#include <vm2matrix.h>
#include <vm3matrix.h>



/*****************************************************************************
*****************************************************************************/
VM2Point::VM2Point(VM2Vector &ref)
{
   px = ref.x(); py = ref.y();
}
   

/*****************************************************************************
*****************************************************************************/
VM2Point operator*(const VM2Matrix& m, const VM2Point &p) 
{
   register int i,j;
   float    vec[2];
   float    res[2];

   vec[0] = p.x(); 
   vec[1] = p.y(); 
   for (i = 0; i < 2; i++) {
      res[i] = 0.0;
      for (j = 0; j < 2; j++)
         res[i] += m(i,j) * vec[j];
   }
   return VM2Point(res[0], res[1]);
}


/*****************************************************************************
*****************************************************************************/
VM2Point operator*(const VM3Matrix& m, const VM2Point &p) 
{
   register int i,j;
   float    vec[4];
   float    res[4];

   vec[0] = p.x(); 
   vec[1] = p.y(); 
   vec[2] = 1.0;
   for (i = 0; i < 3; i++) {
      res[i] = 0.0;
      for (j = 0; j < 3; j++)
         res[i] += m(i,j) * vec[j];
   }
   if (res[2] != 1.0 && res[2] != 0.0) {
      res[0] /= res[2];
      res[1] /= res[2];
   }
   return VM2Point(res[0], res[1]);
}
