#include "vm3point.h"
#include <vm3vector.h>
#include <vm3matrix.h>
#include <vm4matrix.h>



/*****************************************************************************
*****************************************************************************/
VM3Point::VM3Point(VM3Vector &ref)
{
   px = ref.x(); py = ref.y(); pz = ref.z();
}
   

/*****************************************************************************
*****************************************************************************/
VM3Point operator*(const VM3Matrix& m, const VM3Point &p) 
{
   register int i,j;
   float    vec[3];
   float    res[3];

   vec[0] = p.x(); 
   vec[1] = p.y(); 
   vec[2] = p.z();
   for (i = 0; i < 3; i++) {
      res[i] = 0.0;
      for (j = 0; j < 3; j++)
         res[i] += m(i,j) * vec[j];
   }
   return VM3Point(res[0], res[1], res[2]);
}


/*****************************************************************************
*****************************************************************************/
VM3Point operator*(const VM4Matrix& m, const VM3Point &p) 
{
   register int i,j;
   float    vec[4];
   float    res[4];

   vec[0] = p.x(); 
   vec[1] = p.y(); 
   vec[2] = p.z(); 
   vec[3] = 1.0;
   for (i = 0; i < 4; i++) {
      res[i] = 0.0;
      for (j = 0; j < 4; j++)
         res[i] += m(i,j) * vec[j];
   }
   if (res[3] != 1.0 && res[3] != 0.0) {
      res[0] /= res[3];
      res[1] /= res[3];
      res[2] /= res[3];
   }
   return VM3Point(res[0], res[1], res[2]);
}
