#include <vm2matrix.h>
#include <vm3matrix.h>
#include "vm2vector.h"
#include <vm2point.h>


/*****************************************************************************
*****************************************************************************/
VM2Vector::VM2Vector(VM2Point &pt) 
{ 
   vx = pt.x(); vy = pt.y();
}


/*****************************************************************************
*****************************************************************************/
VM2Vector operator*(const VM2Matrix& m, const VM2Vector &v) 
{
   register int i,j;
   float   vec[2];
   float   res[2];

   vec[0] = v.x(); 
   vec[1] = v.y(); 
   for (i = 0; i < 2; i++) {
      res[i] = 0.0;
      for (j = 0; j < 2; j++)
         res[i] += m(i,j) * vec[j];
   }
         
   return VM2Vector(res[0], res[1]);
}


/*****************************************************************************
*****************************************************************************/
VM2Vector operator*(const VM3Matrix& m, const VM2Vector &v) 
{
   register int i,j;
   float   vec[3];
   float   res[3];

   vec[0] = v.x(); 
   vec[1] = v.y(); 
   vec[2] = 0.0;
   for (i = 0; i < 3; i++) {
      res[i] = 0.0;
      for (j = 0; j < 3; j++)
         res[i] += m(i,j) * vec[j];
   }
   if (res[2] != 1.0 && res[2] != 0.0) {
      res[0] /= res[2];
      res[1] /= res[2];
   }
         
   return VM2Vector(res[0], res[1]);
}
